
/* BEGIN software license
 *
 * msXpertSuite - mass spectrometry software suite
 * -----------------------------------------------
 * Copyright (C) 2009--2020 Filippo Rusconi
 *
 * http://www.msxpertsuite.org
 *
 * This file is part of the msXpertSuite project.
 *
 * The msXpertSuite project is the successor of the massXpert project. This
 * project now includes various independent modules:
 *
 * - massXpert, model polymer chemistries and simulate mass spectrometric data;
 * - mineXpert, a powerful TIC chromatogram/mass spectrum viewer/miner;
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * END software license
 */


#pragma once

/////////////////////// StdLib includes


/////////////////////// Qt includes
#include <QWidget>

/////////////////////// QCustomPlot


/////////////////////// pappsomspp includes
#include <pappsomspp/gui/plotwidget/basetraceplotwidget.h>
#include <pappsomspp/core/trace/trace.h>

/////////////////////// Local includes


namespace MsXpS
{
namespace MineXpert
{


class TracePlotLabel: public QObject
{
  Q_OBJECT

  public:
  // The parent MUST be the plot widget (derived from QCustomPlot)
  TracePlotLabel(QObject *parent = nullptr);

  TracePlotLabel(const QString &text,
                 const QString &plot_layer_name,
                 QObject *parent = nullptr);


  TracePlotLabel(const QString &text,
                 const QString &plot_layer_name,
                 const QPointF &data_point,
                 QObject *parent = nullptr);


  TracePlotLabel(const QString &text,
                 const QString &plot_layer_name,
                 const QPointF &data_point,
                 const QPointF &draw_point,
                 QObject *parent = nullptr);


  TracePlotLabel(const QString &text,
                 const QString &plot_layer_name,
                 const QPointF &data_point,
                 const QPointF &draw_point,
                 int vertical_shift_count,
                 QObject *parent = nullptr);

  virtual ~TracePlotLabel();

  void setText(const QString &text);
  QString getText() const;
  void clearText();

  void setPlotLayerName(const QString &plot_layer_name);
  QString getPlotLayerName() const;

  void write(const QFont &font, const QColor &color);

  void show();
  void hide();
  void eraseLabel();
  void setVisible(bool visible);
  bool isVisible();
  void toggleVisibility();

  void setDataPoint(const QPointF &data_point);
  QPointF getDataPoint() const;

  void setDrawPoint(const QPointF &draw_point);
  QPointF getDrawPoint() const;

  void setVerticalShiftCount(int vertical_shift_count);
  int getVerticalShiftCount() const;

  QString toString() const;

  private:
  QCPItemText *mrp_qcpItemText = nullptr;
  QString m_text;
  QString m_plotLayerName = "labelsLayer";
  QPointF m_dataPoint;
  QPointF m_drawPoint;
  int m_verticalShiftCount = 0;
};

typedef QSharedPointer<TracePlotLabel> TracePlotLabelQSPtr;


} // namespace MineXpert

} // namespace MsXpS
